/*
   This piece of code implements the menus used in the Mr. Edit demo. 
   This is supplied as a piece of trivia to demonstrate an interesting
   way to misuse Mr. Edit.  We highly recommend that you don't actually
   use this code, as there are much better menu systems available, 
   including but not limited to MENU TO.

   Copyright 1995, Extrasensory Software   

   Author:  Ira Emus   

*/


#include "inkey.ch"
#include "MrEdit.ch"
#include "config.ch"

#define CRLF chr(13)+chr(10)

function runAcross(menu, hotkey)
   local key
   local cursor  := setcursor(0)
   local i
   local save
   local cChoice := ""
   local lFound  := .f.
   local aMenuKeys := {{K_ALT_F,"F"},;
         {K_ALT_E,"E"},;
         {K_ALT_S,"S"},;
         {K_ALT_C,"C"},;
         {K_ALT_A,"A"},;
         {K_ALT_H,"H"}}

   if !meisBlock(menu)
      meWordBegin(menu)
      meDropAnchor(Menu, BLOCK_INCLUSIVE)
      meWordEnd(menu)
   endif
   medispbegin(menu)
   do while .t.    
      medispend(menu)

      if hotkey > 0 .and. (i := ascan( aMenuKeys, {|x| x[1] == hotkey})) > 0

         key := asc(aMenuKeys[i,2])

      else
         key := inkey(0)
      endif
      hotkey := 0  // disable for the rest of the visit to this function

      medispbegin(menu)
      do case
         case key == K_ESC
            exit
         case key == K_ENTER
            cChoice := meGetMarkedText( menu )
            exit
         case key == K_END
            meRaiseAnchor(menu)
            meEnd(menu)
            meWordLeft(menu)
            meDropAnchor(Menu, BLOCK_INCLUSIVE)
            meWordEnd(menu)
         case key == K_HOME
            meRaiseAnchor(menu)
            meHome(menu)
            meDropAnchor(Menu, BLOCK_INCLUSIVE)
            meWordEnd(menu)
         case key == K_RIGHT
            save := meColPos(menu)
            meRaiseAnchor(menu)
            meWordRight(menu)
            meWordBegin(menu)
            meDropAnchor(Menu, BLOCK_INCLUSIVE)
            meWordEnd(menu)
            if save == meColPos(menu)
               meRaiseAnchor(menu)
               meHome(menu)
               meDropAnchor(Menu, BLOCK_INCLUSIVE)
               meWordEnd(menu)
            endif
         case key == K_LEFT
            save := meColPos(menu)
            meRaiseAnchor(menu)
            meWordBegin(menu)
            meWordLeft(menu)
            meDropAnchor(Menu, BLOCK_INCLUSIVE)
            meWordEnd(menu)
            if save == meColPos(menu)
               meRaiseAnchor(menu)
               meEnd(menu)
               meWordLeft(menu)
               meDropAnchor(Menu, BLOCK_INCLUSIVE)
               meWordEnd(menu)
            endif
         case upper(chr(key)) >="A" .and. upper(chr(key)) <= "Z"
            meRaiseAnchor(menu)
            save := meSetBookMark(menu)
            if !(lFound := mesearch( menu, upper(chr(key)), .t., .t. , .f. ))
               meGoTop(menu)
               if !(lFound := mesearch( menu, upper(chr(key)), .t., .t. , .f. ))
                  megoToBookMark(menu, save)
                  meRight(menu)
                  if !(mesearch( menu, upper(chr(key)), .t., .f. , .f. ))
                     meGoTop(menu)
                     if !(mesearch( menu, upper(chr(key)), .t., .f. , .f. ))
                        meGoTop(menu)
                        megoToBookMark(menu, save)
                     endif
                  endif
               endif
            endif
            meFreeBookMark(menu, save)
            meWordBegin(menu)
            meDropAnchor(Menu, BLOCK_INCLUSIVE)
            meWordEnd(menu)
            if lFound
               cChoice := meGetMarkedText( menu )
               exit
            endif
      endcase

   enddo
   medispend(menu)
   setcursor(cursor)
   return cChoice



function runDown( menu, across )
   local key
   local cursor := setcursor(0)
   local i
   local cChoice := ""
   local save
   local length := 0
   local lFound := .f.
   local scrn   := ""

   if mesettop( menu ) == 0
      meBlockSwap( Across )
      do while .t. 
         meEnd(menu)
         length := max(length, meColPos(menu) )
         if meEof(menu)
            exit
         endif
         meHome(menu)
         meDown(menu)
      enddo
      meSetBottom(menu,  meLinePos(menu)+2 )
      meSetTop(menu, 1)
      meSetRight(menu, col()+length-1 )
      meSetLeft(menu,  col() )
      meGoTop(menu)
      meBlockSwap( Across )
      medispcount(menu)

   endif
   scrn   := savescreen(meSetTop(menu), meSetLeft(menu), ;
         meSetBottom(menu), meSetRight(menu) )
   do while .t.    
      meDropAnchor(Menu, BLOCK_LINE)
      medispend(menu)
      key := inkey(0)
      medispbegin(menu)
      meRaiseAnchor(menu)
      do case
         case key == K_ESC
            exit
         case key == K_ENTER
            cChoice := meGetLine( menu )
            exit
         case key == K_END
            meGoBottom(menu)
         case key == K_HOME
            meGoTop(menu)
         case key == K_UP
            save := meLinePos(menu)
            meUp(menu)
            if save == meLinePos(menu)
               meGoBottom(menu)
            endif
         case key == K_DOWN
            save := meLinePos(menu)
            meDown(menu)
            if save == meLinePos(menu)
               meGoTop(menu)
            endif
         case upper(chr(key)) >="A" .and. upper(chr(key)) <= "Z"
            save := meSetBookMark(menu)
            meRight(menu)
            if !(lFound := mesearch( menu, upper(chr(key)), .t., .t. , .f. ))
               meGoTop(menu)
               if !(lFound := mesearch( menu, upper(chr(key)), .t., .t. , .f. ))
                  megoToBookMark(menu, save)
                  meEnd(menu)
                  if ! (mesearch( menu, upper(chr(key)), .t., .f. , .f. ))
                     meGoTop(menu)
                     if ! (mesearch( menu, upper(chr(key)), .t., .f. , .f. ))
                        meGoTop(menu)
                        megoToBookMark(menu, save)
                     endif
                  endif
               endif
            endif
            meFreeBookMark(menu, save)
            if lFound
               cChoice := meGetLine( menu )
               exit
            endif
         case key == K_RIGHT
            keyboard(chr(key)+chr(13))
            exit
         case key == K_LEFT
            keyboard(chr(key)+chr(13))
            exit
      endcase

   enddo
   restscreen( meSetTop(menu), meSetLeft(menu), ;
         meSetBottom(menu), meSetRight(menu), scrn)
   setcursor(cursor)
   return cChoice


